"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Action(ProtocolElement):
    """
    A clinical action
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "source",
        "variantActionable",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "actionType": reports_5_0_0.ActionType,
            "status": reports_5_0_0.ActionStatus,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "org.gel.models.report.avro.ActionType": reports_5_0_0.ActionType,
            "org.gel.models.report.avro.ActionStatus": reports_5_0_0.ActionStatus,
            "org.gel.models.report.avro.Action": reports_5_0_0.Action,
        }

    __slots__ = [
        "source",
        "variantActionable",
        "actionType",
        "evidenceType",
        "references",
        "status",
        "url",
    ]

    def __init__(
        self,
        source,
        variantActionable,
        actionType=None,
        evidenceType=None,
        references=None,
        status=None,
        url=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_5_0_0.Action model.

        :param source:
            Source of the information
        :type source: str
        :param variantActionable:
            Flag indicating if the variant is actionable
        :type variantActionable: boolean
        :param actionType:
            Type of clinical action
        :type actionType: None | ActionType
        :param evidenceType:
            Type of evidence
        :type evidenceType: None | str
        :param references:
            List of PubMed identifiers
        :type references: None | list[str]
        :param status:
            Status of the action
        :type status: None | ActionStatus
        :param url:
            Link to original source
        :type url: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "5.0.0"
